<< ../main/oneloop.m;

(* QED corrections (with soft and collinear singularities) to 
   nu(p1) nubar(p2) -> e(p3) ebar(p4) *)

d0den = {k1 . k1, (k1 - p3) . (k1 - p3), -mws + (k1 + p1 - p3) . (k1 + p1 - p3),
 (k1 + p1 + p2 - p3) . (k1 + p1 + p2 - p3)};
d0num = -(-(mws*(k1 . k1 - 2*p3 . k1)*(k1 . k1 + 2*p1 . k1 + 2*p1 . p2 + 2*p2 . k1 -
      2*p3 . k1 - 2*p3 . p1 - 2*p3 . p2)*(-4*p1 . p2*p3 . p2 +
      (-2 + $d)*p3 . p1*(-p1 . p2 + p3 . p2))) -
   3*(k1 . k1 - 2*p3 . k1)*(-mws + k1 . k1 + 2*p1 . k1 - 2*p3 . k1 -
     2*p3 . p1)*(k1 . k1 + 2*p1 . k1 + 2*p1 . p2 + 2*p2 . k1 - 2*p3 . k1 -
     2*p3 . p1 - 2*p3 . p2)*(-4*p1 . p2*p3 . p2 +
     (-2 + $d)*p3 . p1*(-p1 . p2 + p3 . p2)) +
   (mws - t)^2*(p1 . p2*p3 . k1*(4*p1 . k1 - $d*p1 . k1 -
       4*(-4 + $d)*p1 . p2 + 4*p2 . k1 - 2*$d*p2 . k1 +
       (-8 + 3*$d)*p3 . k1) + 4*(-2 + $d)*p1 . p2*(p3 . p1)^2 +
     (-8*p1 . p2*(k1 . k1 + p1 . k1 + 2*p2 . k1) +
       p1 . k1*((-4 + $d)*p1 . k1 - 2*(-2 + $d)*p2 . k1) +
       ((8 - 3*$d)*p1 . k1 + 4*(2 + $d)*p1 . p2)*p3 . k1)*p3 . p2 +
     16*p1 . p2*(p3 . p2)^2 + p3 . p1*(4*k1 . k1*p1 . p2 -
       3*$d*k1 . k1*p1 . p2 + 8*p1 . k1*p1 . p2 - 4*$d*p1 . k1*p1 . p2 +
       4*p1 . k1*p2 . k1 - $d*p1 . k1*p2 . k1 - 8*p1 . p2*p2 . k1 -
       4*(p2 . k1)^2 + 2*$d*(p2 . k1)^2 + (8*(-2 + $d)*p1 . p2 +
         (8 - 3*$d)*p2 . k1)*p3 . k1 + ((-8 + 3*$d)*k1 . k1 + 16*p1 . p2)*
        p3 . p2)) + 2*(-mws + t)*(k1 . k1 + 2*p1 . k1 + 2*p1 . p2 +
     2*p2 . k1 - 2*p3 . k1 - 2*p3 . p1 - 2*p3 . p2)*
    (p1 . p2*p3 . k1*(-((-6 + $d)*p1 . p2) +
       (-2 + $d)*(p1 . k1 - 2*p2 . k1) + (-2 + $d)*p3 . k1) +
     (-((4*k1 . k1 + (2 + $d)*p1 . k1)*p1 . p2) - (-2 + $d)*p1 . k1*
        (p1 . k1 + 2*p2 . k1) + (-((-2 + $d)*p1 . k1) + (2 + $d)*p1 . p2)*
        p3 . k1)*p3 . p2 + (2 + $d)*p1 . k1*(p3 . p2)^2 -
     (-2 + $d)*(p3 . p1)^2*(-2*p1 . p2 + p2 . k1 + 2*p3 . p2) +
     p3 . p1*(4*k1 . k1*p1 . p2 - 2*$d*k1 . k1*p1 . p2 + 4*p1 . k1*p1 . p2 -
       2*$d*p1 . k1*p1 . p2 - 2*p1 . k1*p2 . k1 + $d*p1 . k1*p2 . k1 -
       6*p1 . p2*p2 . k1 + $d*p1 . p2*p2 . k1 - 4*(p2 . k1)^2 +
       2*$d*(p2 . k1)^2 + (-2 + $d)*(p1 . p2 - p2 . k1)*p3 . k1 +
       (-4*k1 . k1 + 2*$d*k1 . k1 + 3*(-2 + $d)*p1 . k1 + 8*p1 . p2 -
         2*p2 . k1 - $d*p2 . k1)*p3 . p2)) + 2*(k1 . k1 - 2*p3 . k1)*
    (k1 . k1 + 2*p1 . k1 + 2*p1 . p2 + 2*p2 . k1 - 2*p3 . k1 - 2*p3 . p1 -
     2*p3 . p2)*(5*p1 . p2*p3 . k1*(p1 . k1 - p1 . p2 - 2*p2 . k1 +
       p3 . k1) - ((4*k1 . k1 + 9*p1 . k1)*p1 . p2 +
       5*p1 . k1*(p1 . k1 + 2*p2 . k1) + (5*p1 . k1 - 9*p1 . p2)*p3 . k1)*
      p3 . p2 + 5*p1 . k1*(p3 . p2)^2 - 5*(p3 . p1)^2*
      (-((-2 + $d)*p1 . p2) + p2 . k1 + (-2 + $d)*p3 . p2) -
     p3 . p1*(3*k1 . k1*p1 . p2 + $d*k1 . k1*p1 . p2 - 2*p1 . k1*p1 . p2 +
       $d*p1 . k1*p1 . p2 - 5*p1 . k1*p2 . k1 - 5*p1 . p2*p2 . k1 -
       10*(p2 . k1)^2 - ((3 + $d)*p1 . p2 - 5*p2 . k1)*p3 . k1 -
       (3*k1 . k1 + $d*k1 . k1 + (3 + $d)*p1 . k1 + 20*p1 . p2 - 5*p2 . k1 -
         (-2 + $d)*p3 . k1)*p3 . p2)) + 2*(mws - t)*(-k1 . k1 + 2*p3 . k1)*
    (p1 . p2*p3 . k1*(-2*(-3 + $d)*p1 . p2 +
       (-2 + $d)*(p1 . k1 - 2*p2 . k1) + (-2 + $d)*p3 . k1) +
     (-4*(p1 . p2)^2 - (-2 + $d)*p1 . k1*(p1 . k1 + 2*p2 . k1) -
       2*p1 . p2*((1 + $d)*p1 . k1 + 2*(k1 . k1 + 2*p2 . k1)) +
       (-((-2 + $d)*p1 . k1) + 2*(1 + $d)*p1 . p2)*p3 . k1)*p3 . p2 +
     2*((-3 + $d)*p1 . k1 + 2*p1 . p2)*(p3 . p2)^2 +
     (p3 . p1)^2*((-2 + $d)*p1 . p2 + (-4 + $d)*p2 . k1 -
       (-2 + $d)*p3 . p2) + p3 . p1*(4*k1 . k1*p1 . p2 -
       2*$d*k1 . k1*p1 . p2 - 2*(p1 . p2)^2 + $d*(p1 . p2)^2 -
       2*p1 . k1*p2 . k1 + $d*p1 . k1*p2 . k1 - 4*p1 . p2*p2 . k1 +
       $d*p1 . p2*p2 . k1 - 4*(p2 . k1)^2 + 2*$d*(p2 . k1)^2 +
       (2*(-1 + $d)*p1 . p2 - (-2 + $d)*p2 . k1)*p3 . k1 +
       (-4*k1 . k1 + 2*$d*k1 . k1 + 2*(-1 + $d)*p1 . k1 -
         2*(-8 + $d)*p1 . p2 + 4*p2 . k1 - $d*p2 . k1)*p3 . p2 +
       (-2 + $d)*(p3 . p2)^2)))/(2*(-mws + t)^3);

pars = {mws,s,t};
momext = {p1,p2,p3};
rels = {Dot[p1,p1]->0, Dot[p2,p2]->0, Dot[p3,p3]->0, Dot[p1,p2]->s/2, 
        Dot[p1,p3]->(-t)/2, Dot[p2,p3]->(s+t)/2};

d0num = SubSoft[d0den, d0num, k1, k1];
d0num = SubColl[d0den, d0num, k1, k1->p3];
d0num = SubColl[d0den, d0num, k1, k1->-(p1+p2-p3)];

d0 = OneLoop[d0den, d0num, k1];
WriteCode[d0, Deform->True, WorkingDirectory->"nenm_em"]
