<<../main/ twoloop.m;

(* scalar two-loop integral with soft and UV divergence
   (Fig.5 in arXiv:1205.3515) *)

tden = {k2.k2 - Ms, (k2+p1+p2).(k2+p1+p2) - Ms,
       (k2+p1).(k2+p1), (k1+p1).(k1+p1) - Ms, (k1-k2).(k1-k2) - Ms};
tnum = 1;
 
pars = {ps,Ms};  muUV2=Ms;
momext = {p1,p2};
rels = {Dot[p1,p1]->Ms, Dot[p2,p2]->Ms, Dot[p1,p2]->ps/2-Ms};

tnum = SubSoft[tden, tnum, k2, k2+p1];

res = TwoLoop[tden, tnum, k1, k2, SimpLevel->3, StatusInfo->2];
WriteCode[res, Deform->True, WorkingDirectory->"t5"];
