(*****************************************************************************
 NICODEMOS version 1.1 (Aug 2012)
 Author: Ayres Freitas (afreitas@pitt.edu)

 Release notes:
 
 NICODEMOS may be used freely for non-commercial purposes, with proper
 acknowledgement of the author and citation of the original publication:
  A. Freitas, arXiv:1205.3515
 If you include it as part of a different program, proper acknowledgement 
 must be given in the documentation of the program.
 
 The NICODEMOS package includes the package FORMAT 2.0 by Mark Sofroniou
 (Copyright 1992-2003,  Mark Sofroniou).
 
 It furthermore requires the CUBA numerical integration library by Thomas Hahn, 
 which can be obtained from http://www.feynarts.de/cuba/Cuba-1.4.tar.gz.

 The author does not promise that this software works, but bug reports are
 welcome.

 For further information see the manual.
*****************************************************************************
 Version history:
 ----------------
 
 version 1.1 (Aug 2012): added capability for treating two-loop integrals
                         with UV and subloop IR singularities
			 (i.e. functionality described in arXiv:1205.3515)
 
 version 1.0 (May 2012): first version, includes only one-loop functionality
 
*****************************************************************************)

$NicoDir = DirectoryName[File /. FileInformation[$Input]];
Get[ToFileName[$NicoDir, "paths"]];

Get[ToFileName[$NicoDir, "Format.m"]];
Off[AssignFunction::undef];

Get[ToFileName[$NicoDir, "onecode.m"]];
